/****************************************************************************************************

		IEx2DImportFilter.h
		Copyright: (c) 2001 Eovia Corp. All rights reserved.

		Author:	charles
		Date:	9/16/2005

****************************************************************************************************/

#ifndef __IEx2DImportFilter__
#define __IEx2DImportFilter__

#if CP_PRAGMA_ONCE
#pragma once
#endif

MCDEFINE_GUID_H(IID_IEx2DImportFilter);


struct IMCFile;
struct IShRasterLayer;
struct IShLayerList;


struct IEx2DImportFilter : public IMCUnknown
{
	// ****************************************************************************
	//								Open
	// 
	/// Loads an image from a file.
	/// 
	/// \param file         The file where the image is stored.
	/// \param rasterLayer  The image.
	/// \param chunky       If true the image must be stored in one channel RGBA
	/// 
	virtual boolean		MCCOMAPI Open(IMCFile* file,IShRasterLayer* rasterLayer,boolean chunky) = 0;

	// ****************************************************************************
	//								Open
	// 
	/// Loads an image from a file as a layer list.
	/// 
	/// \param file         The file where the image is stored.
	/// \param layerList	The layer list.
	/// \param chunky       If true the image must be stored in one channel RGBA
	/// 
	virtual MCCOMErr	MCCOMAPI Open(IMCFile* file, IShLayerList* layerList, boolean chunky) = 0;
};


struct I2DShImportFilter : public IEx2DImportFilter
{
};

#endif
